;--------------------------------------
; RGB    
;  1.0.
; ()  .. (Len9)
; 1  2013 .
; www.radiokot.ru
;--------------------------------------

.includepath "/usr/share/avra/" ;    
.include "tn13def.inc"
; : Lo = $7A; Hi = $F9


;----------  ----------
.equ	ValidScanOn = 20		;    ,  /
.equ	ValidScanColor = 30		; ,  
.equ	ValidScanBright = 8		; ,  
.equ	VOnOff = $D7			; / (256*/5)
.equ	VColor = $6A			;   (256*/5)
.equ	VBright = $34			;   (256*/5)
.equ	MaxStep = 8				;   

.equ	ColorData = $40			;       


;----------  ----------
.def	PWM = r0				; 
.def	PWMR = r1				;  
.def	PWMG = r2				;  
.def	PWMB = r3				;  
.def	Bright = r4				;  (0-32)
.def	BrightR = r5			;  (0-8)
.def	BrightG = r6			;  (0-8)
.def	BrightB = r7			;  (0-8)
.def	PWMRTemp = r8			;    
.def	PWMGTemp = r9			;    
.def	PWMBTemp = r10			;    
.def	Temp = r16				; 
.def	Temp2 = r17				; 
.def	TempSREG = r18			;    SREG
.def	Events = r19			; 
.def	Flags = r20				; 
.def	CountScan = r21			; ,   
.def	VOff = r22				;    
.def	VOn = r23				;    
.def	ColorStep = r24			;    ( 0..3 -  , 4..7 -   )


		; B:
.equ	RLed = 0				; 
.equ	GLed = 1				; 
.equ	BLed = 2				; 
.equ	IRLed = 3				; 
.equ	IRPhoto = 4				; 


		;:
.equ	FOn = 0					;0 -  , 1 - 
.equ	FOnOff = 1				;1 -  /
.equ	FColor = 2				;1 -   
.equ	FBright = 3				;1 -   
.equ	FBrightUp = 4			;0 -   , 1 - 


		;:
.equ	ADCConv = 0				;  
.equ	EOn = 1					;  /
.equ	EColor = 2				;   
.equ	EBright = 3				;   


;----------  EEPROM ----------
.eseg
; :
;$00 -  
;$01 - Bright -  
;$02 - BrightR -   
;$03 - BrightG -  
;$04 - BrightB -  
;$05 - ColorStep -   
;$06 - Flags - 
.db $00, $20, $08, $08, $08, $00, $00


;----------   ----------
.cseg
 rjmp	Main					;   
.org	OVF0addr				;   
 rjmp	TimerOvf
.org	ADCCaddr				;    
 rjmp	ADCInt


;  
.org	ColorData / 2			;  
; :
; 0 -   
; 1 -   
; 2 -   
; 3 -   
; 4 -   
; 5 -   
; 6,7 -  
.db $08, $10, $01, $20, $02, $08, $04, $01


;---------- TIM0ovf     ----------
TimerOvf:
 in		TempSREG, SREG			; 
 push	Temp
 inc	PWM						;  
 tst	PWM
 brne	TOvf1					;  0, 
 mov	PWMR, PWMRTemp
 mov	PWMG, PWMGTemp
 mov	PWMB, PWMBTemp
 tst	PWMR					; 
 breq	PC+3					; 0, 
 sbi	PORTB, RLed				; ,     0
 rjmp	PC+2
 cbi	PORTB, RLed				; ,    0
 tst	PWMG					; 
 breq	PC+3					; 0, 
 sbi	PORTB, GLed				; ,     0
 rjmp	PC+2
 cbi	PORTB, GLed				; ,    0
 tst	PWMB					; 
 breq	PC+3					; 0, 
 sbi	PORTB, BLed				; ,     0
 rjmp	PC+2
 cbi	PORTB, BLed				; ,    0
 rjmp	TOvf2
TOvf1:
 ser	Temp
 cp		PWM, Temp				; =$FF,     
 breq	TOvf2
 cp		PWM, PWMR				;      
 brne	PC+2					; ,   
 cbi	PORTB, RLed				;  
 cp		PWM, PWMG				;      
 brne	PC+2					; ,   
 cbi	PORTB, GLed				;  
 cp		PWM, PWMB				;      
 brne	PC+2					; ,   
 cbi	PORTB, BLed				;  
TOvf2:
 pop	Temp
 out	SREG, TempSREG			; 
 reti


;----------      ----------
ADCInt:
 in		TempSREG, SREG			; 
 sbic	PORTB, IRLed			;   
 in		VOff, ADCH				;     
 sbis	PORTB, IRLed			;   
 in		VOn, ADCH				;     
 sbr	Events, (1<<ADCConv)	;    
 out	SREG, TempSREG			; 
 reti


;----------  ~3 ----------
Delay:
 clr	Temp
 ldi	Temp2, $20
 dec	Temp
 brne	PC-1
 dec	Temp2
 brne	PC-3
 ret


;----------    ----------
CalculateBright:
 clr	PWMRTemp				;  = Bright*BrightR
 mov	Temp, BrightR
 inc	Temp
 dec	Temp
 breq	PC+4
 add	PWMRTemp, Bright
 brcc	PC-3					;   
 dec	PWMRTemp				;    ($00-$01=$FF)
 clr	PWMGTemp				;  = Bright*BrightG
 mov	Temp, BrightG
 inc	Temp
 dec	Temp
 breq	PC+4
 add	PWMGTemp, Bright
 brcc	PC-3					;   
 dec	PWMGTemp				;    ($00-$01=$FF)
 clr	PWMBTemp				;  = Bright*BrightB
 mov	Temp, BrightB
 inc	Temp
 dec	Temp
 breq	PC+4
 add	PWMBTemp, Bright
 brcc	PC-3					;   
 dec	PWMBTemp				;    ($00-$01=$FF)
 ret


;---------- /  ----------
OnOffLamp:
 sbrc	Flags, FOn				;   
 rjmp	PC+5
 rcall	CalculateBright
 sbr	Flags, (1<<FOn)			; ,  
 rcall	WriteEEPROM				; 
 ret
 clr	PWMRTemp				; 
 clr	PWMGTemp
 clr	PWMBTemp
 cbr	Flags, (1<<FOn)			; ,  
 rcall	WriteEEPROM				; 
 ret


;----------    ----------
BrightLamp:
 sbrc	Flags, FBrightUp		;   ?
 rjmp	BrightLamp1				;, , 
 dec	Bright					; 
 ldi	Temp, $01
 cp		Bright, Temp			; ?
 brne	BrightLampEnd			;   , 
 sbr	Flags, (1<<FBrightUp)	; ,     
 rjmp	BrightLampEnd
BrightLamp1:					; 
 inc	Bright					; 
 ldi	Temp, 32
 cp		Bright, Temp			;  
 brne	BrightLampEnd			;   , 
 cbr	Flags, (1<<FBrightUp)	; ,     
BrightLampEnd:
 rcall	CalculateBright			;  
 rcall	WriteEEPROM				; 
 ret


;----------    ----------
ColorLamp:
 ldi	Temp, ColorData			;     
 mov	ZL, Temp
 clr	ZH
 mov	Temp, ColorStep			;  
 andi	Temp, $0F
 add	ZL, Temp				;  
 lpm	Temp, Z					;    
 sbrc	Temp, 0					; 0 ?
 inc	BrightR					;  
 sbrc	Temp, 1					; 1 ?
 inc	BrightG					;  
 sbrc	Temp, 2					; 2 ?
 inc	BrightB					;  
 sbrc	Temp, 3					; 3 ?
 dec	BrightR					;  
 sbrc	Temp, 4					; 4 ?
 dec	BrightG					;  
 sbrc	Temp, 5					; 5 ?
 dec	BrightB					;  
 mov	Temp, ColorStep
 swap	Temp
 andi	Temp, $0F				; Temp   
 andi	ColorStep, $0F			; 
 inc	Temp
 cpi	Temp, 8					;   
 brne	ColorLampEnd			;    
 clr	Temp					; ,  
 inc	ColorStep				;     
 cpi	ColorStep, MaxStep		;    
 brne	ColorLampEnd			;  , 
 clr	ColorStep				; ,   
ColorLampEnd:
 swap	Temp
 or		ColorStep, Temp			; 
 rcall	CalculateBright			;  
 rcall	WriteEEPROM				; 
 ret


;----------    EEPROM    ----------
StrobeAndWaitEEPROM:
 cli							; 
 sbi	EECR, EEMWE
 sbi	EECR, EEWE				;
 sei							; 
 sbic	EECR, EEPE				;  EEPROM
 rjmp	PC-1
 ret


;----------     EEPROM ----------
WriteEEPROM:
 sbic	EECR, EEPE
 rjmp	PC-1					;  EEPROM
 ldi	Temp, (0<<EEPM1)|(0<<EEPM0)
 out	EECR, Temp				; EEPROM:     
 ldi	Temp, $01
 out	EEARL, Temp				;    $01
 out	EEDR, Bright			; 
 rcall	StrobeAndWaitEEPROM		;
 inc	Temp					; 
 out	EEARL, Temp
 out	EEDR, BrightR			; 
 rcall	StrobeAndWaitEEPROM		;
 inc	Temp					; 
 out	EEARL, Temp
 out	EEDR, BrightG			; 
 rcall	StrobeAndWaitEEPROM		;
 inc	Temp					; 
 out	EEARL, Temp
 out	EEDR, BrightB			; 
 rcall	StrobeAndWaitEEPROM		;
 inc	Temp					; 
 out	EEARL, Temp
 out	EEDR, ColorStep			;  
 rcall	StrobeAndWaitEEPROM		;
 inc	Temp					; 
 out	EEARL, Temp
 out	EEDR, Flags				;
 rcall	StrobeAndWaitEEPROM		;
 clr	Temp					;     0
 out	EEARL, Temp
 ret


;----------     EEPROM ----------
ReadEEPROM:
 sbic	EECR, EEPE
 rjmp	PC-1					;  EEPROM
 ldi	Temp, $01
 out	EEARL, Temp				;    $01
 sbi	EECR, EERE				; EEPROM
 in		Bright, EEDR			; 
 inc	Temp					; 
 out	EEARL, Temp
 sbi	EECR, EERE				; EEPROM
 in		BrightR, EEDR			; 
 inc	Temp					; 
 out	EEARL, Temp
 sbi	EECR, EERE				; EEPROM
 in		BrightG, EEDR			; 
 inc	Temp					; 
 out	EEARL, Temp
 sbi	EECR, EERE				; EEPROM
 in		BrightB, EEDR			; 
 inc	Temp					; 
 out	EEARL, Temp
 sbi	EECR, EERE				; EEPROM
 in		ColorStep, EEDR			;  
 inc	Temp					; 
 out	EEARL, Temp
 sbi	EECR, EERE				; EEPROM
 in		Flags, EEDR				;
 clr	Temp					;     0
 out	EEARL, Temp
 ret


;----------   ----------
Main:
 ldi	Temp, 0b00001111		;  
 out	DDRB, Temp
 ldi	Temp, 0b00100010		; ADC: MUX=PB4
 out	ADMUX, Temp
 ldi	Temp, 0b10001111		; ADC: f/128
 out	ADCSRA, Temp
 ldi	Temp, 0b00000001		;Timer0 = clc
 out	TCCR0B, Temp
 ldi	Temp, 0b00000010		;    
 out	TIMSK0, Temp
 clr	PWMR					; 
 clr	PWMG
 clr	PWMB
 clr	PWMRTemp
 clr	PWMGTemp
 clr	PWMBTemp
 clr	CountScan
 rcall	ReadEEPROM				;  
 sbrc	Flags, FOn				; ?
 rcall	CalculateBright			;,  
 clr	Events					; 
 sei							; 

Loop:
 sbrs	Events, EOn				;  /?
 rjmp	PC+3
 cbr	Events, (1<<EOn)		; 
 rcall	OnOffLamp				; / 
 
 sbrs	Events, EColor			;   ?
 rjmp	PC+3
 cbr	Events, (1<<EColor)		; 
 rcall	ColorLamp				;  

 sbrs	Events, EBright			;   ?
 rjmp	PC+3
 cbr	Events, (1<<EBright)	; 
 rcall	BrightLamp				;  

 rcall	Delay					;
 sbi	ADCSRA, ADSC			; 
 sbrs	Events, ADCConv			;   
 rjmp	PC-1					;
 cbr	Events, (1<<ADCConv)	;    
 sbi	PORTB, IRLed			;  
 rcall	Delay					;
 sbi	ADCSRA, ADSC			; 
 sbrs	Events, ADCConv			;   
 rjmp	PC-1					;
 cbr	Events, (1<<ADCConv)	;    
 cbi	PORTB, IRLed			;  
 sub	VOn, VOff				; 
 brcs	Loop					;  , 

 cpi	VOn, VOnOff				;  /?
 brcc	LoopOnOff				;, 
 cbr	Flags, (1<<FOnOff)		;    /
 sbrs	Flags, FOn				; ?
 rjmp	Loop					;, 
 cpi	VOn, VColor				;  ?
 brcc	LoopColor				;, 
 cpi	VOn, VBright			;  ?
 brcc	LoopBright				;, 
 cbr	Flags, (1<<FColor)		;    
 cbr	Flags, (1<<FBright)		;    
 rjmp	Loop

LoopOnOff:						;  /
 sbrs	Flags, FOnOff			;  ?
 clr	CountScan				;,   
 sbr	Flags, (1<<FOnOff)		;   /
 cbr	Flags, (1<<FColor)		;    
 cbr	Flags, (1<<FBright)		;    
 cpi	CountScan, $FF			;    
 breq	Loop					; ,    ,    
 inc	CountScan				;  
 cpi	CountScan, ValidScanOn	; ?
 brne	Loop					;, 
 sbr	Events, (1<<EOn)		;  /
 rjmp	Loop

LoopColor:
 sbrs	Flags, FColor			;  ?
 clr	CountScan				;,   
 cbr	Flags, (1<<FOnOff)		;   /
 sbr	Flags, (1<<FColor)		;    
 cbr	Flags, (1<<FBright)		;    
 inc	CountScan				;  
 cpi	CountScan, ValidScanColor	; ?
 brne	PC+3					;, 
 sbr	Events, (1<<EColor)		;   
 clr	CountScan				;  ,   
 rjmp	Loop

LoopBright:						;  
 sbrs	Flags, FBright			;  ?
 clr	CountScan				;,   
 cbr	Flags, (1<<FOnOff)		;   /
 cbr	Flags, (1<<FColor)		;    
 sbr	Flags, (1<<FBright)		;    
 inc	CountScan				;  
 cpi	CountScan, ValidScanBright	; ?
 brne	PC+3					;, 
 sbr	Events, (1<<EBright)	;   
 clr	CountScan				;  ,   
 rjmp	Loop
